<?php

defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: form.php,v 1.6 2010-11-14 19:34:41 harry Exp $
 * @package Joomla
 * @subpackage H2N Mosimage Component
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de

 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Mosimage Component is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Mosimage Component is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

?>
		
<script language="javascript" type="text/javascript">		
	var folderimages = new Array;
<?php
	$i = 0;
	foreach ($this->images as $k=>$items) {
		foreach ($items as $v) {
			echo "folderimages[".$i++."] = new Array( '$k','".addslashes( $v->value )."','".addslashes( $v->text )."' );\t";
		}
	}
?>

function submitbutton(pressbutton) {
	var form = document.adminForm;

	if (pressbutton == 'cancel') {
		submitform( pressbutton );
		return;
	}
	// assemble the images back into one field
	var temp = new Array;
	for (var i=0, n=form.imagelist.options.length; i < n; i++) {
		temp[i] = form.imagelist.options[i].value;
	}
	form.images.value = temp.join( '\n' );

	submitform( pressbutton );
}

</script>
	<form action="index.php" method="post" name="adminForm" id="adminForm">
		<div class="col" style="width: 100%;">
			<fieldset class="adminform">
				<legend><?php echo JText::_('MOSImage Control'); ?></legend>			
				<table class="admintable" width="100%" cellspacing="1">
					<tr>
						<td colspan="2">
							<table width="100%">
							<tr>
								<td width="48%" valign="top">
									<div align="center">
										<?php echo JText::_('Gallery Images');?>:
										<br />
										<?php echo $this->lists['imagefiles'];?>
									</div>
								</td>
								<td width="2%">
									<input class="button" type="button" value=">>" onclick="addSelectedToList('adminForm','imagefiles','imagelist')" title="Add" />
									<br />
									<input class="button" type="button" value="&lt;&lt;" onclick="delSelectedFromList('adminForm','imagelist')" title="Remove" />
								</td>
								<td width="48%">
									<div align="center">
										<?php echo JText::_('Content Images');?>:
										<br />
										<?php echo $this->lists['imagelist'];?>
										<br />
										<input class="button" type="button" value="Up" onclick="moveInList('adminForm','imagelist',adminForm.imagelist.selectedIndex,-1)" />
										<input class="button" type="button" value="Down" onclick="moveInList('adminForm','imagelist',adminForm.imagelist.selectedIndex,+1)" />
									</div>
								</td>
							</tr>
							</table>
							<?php echo JText::_('Sub-folder');?>: <?php echo $this->lists['folders'];?>
						</td>
					</tr>
					<tr valign="top">
						<td>
							<div align="center"><?php echo JText::_('Sample Image');?>:<br />
								<img name="view_imagefiles" src="../images/M_images/blank.png" alt="Sample Image" width="100" />
							</div>
						</td>
						<td valign="top">
							<div align="center"><?php echo JText::_('Active Image');?>:<br />
								<img name="view_imagelist" src="../images/M_images/blank.png" alt="Active Image" width="100" />
							</div>
						</td>
					</tr>
				</table>
			</fieldset>	
		</div>
		<div class="col width-70">
			<fieldset class="adminform">
				<legend><?php echo JText::_('Edit the image selected'); ?></legend>			
				<table class="admintable" width="100%" cellspacing="1">
					<tr>
						<td colspan="2">
							<table>
								<tr>
									<td class="key"><?php echo JText::_('Source');?>:</td>
									<td><input class="inputbox" type="text" name= "_source" value="" size="60" disabled="disabled" /></td>
								</tr>
								<tr>
									<td class="key"><?php echo JText::_('Image Align');?>:</td>
									<td><?php echo $this->lists['_align']; ?></td>
								</tr>
								<tr>
									<td class="key"><?php echo JText::_('Alt Text'); ?>:</td>
									<td><input class="inputbox" type="text" name="_alt" value="" size="60" /></td>
								</tr>
								<tr>
									<td class="key"><?php echo JText::_('Border'); ?>:</td>
									<td><input class="inputbox" type="text" name="_border" value="" size="3" maxlength="1" /></td>
								</tr>
								<tr>
									<td class="key"><?php echo JText::_('Caption'); ?>:</td>
									<td><input class="inputbox" type="text" name="_caption" value="" size="60" /></td>
								</tr>
								<tr>
									<td colspan="2"><input class="button" type="button" value="<?php echo JText::_('Apply');?>" onclick="applyImageProps()" /></td>
								</tr>
								
							</table>
						</td>
					</tr>
				</table>
			</fieldset>
		</div>
		<div class="col width-30">	
			<fieldset class="adminform">
				<legend><?php echo JText::_('Caption properties'); ?></legend>			
				<table class="admintable" width="100%" cellspacing="1">
					<tr>
						<td colspan="2">
							<table>
								<!-- @TODO Bildunterschriften bei den Vorschaubildern klappt momentan nicht, da 
								     das Umfließen der Bilder noch nicht klappt -->
								<tr>
									<td class="key"><?php echo JText::_('Caption Position'); ?>:</td>
									<td><?php echo $this->lists['_caption_position']; ?></td>
								</tr>
								<tr>
									<td  class="key"><?php echo JText::_('Caption Align'); ?>:</td>
									<td><?php echo $this->lists['_caption_align']; ?></td>
								</tr>
								<tr>
									<td class="key"><?php echo JText::_('Caption Width');?>:</td>
									<td><input class="inputbox" type="text" name="_width" value="" size="5" maxlength="5" disabled="disabled" /></td>
								</tr>	
							</table>
						</td>
					</tr>
				</table>
			</fieldset>
		</div>
		<div class="col" style="width: 100%;">
			<fieldset class="adminform">		
				<div style="float: right">
					<button type="button" onclick="window.parent.document.getElementById('sbox-window').close();"><?php echo JText::_('Cancel');?></button>
				</div>
				<input type="hidden" name="option" value="com_mosimage" />
				<input type="hidden" name="cid[]" value="<?php echo $this->id; ?>" />
				<input type="hidden" name="tmpl" value="component" />
				<input type="hidden" name="task" value="saveMosimageOption" />
				<?php echo JHTML::_( 'form.token' ); ?>
				<input type="hidden" name="images" value="" />
				<button type="button" class="button" onclick="submitbutton('saveMosimageOption');"><?php echo JText::_('Save');?></button>
			</fieldset>
		</div> 		
</form>
