<?php 

defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: view.html.php,v 1.7 2010-11-18 19:19:50 harry Exp $
 * @package Joomla
 * @subpackage H2N Mosimage Component
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Mosimage Component is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Mosimage Component is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

?>
<script type="text/javascript">

	function previewImage( list, image, base_path ) {
		form = document.adminForm;
		srcList = eval( "form." + list );
		srcImage = eval( "document." + image );
		var srcOption = srcList.options[(srcList.selectedIndex < 0) ? 0 : srcList.selectedIndex];
		var fileName = srcOption.text;
		var fileName2 = srcOption.value;
		if (fileName.length == 0 || fileName2.length == 0) {
			srcImage.src = 'images/blank.gif';
		} else {
			srcImage.src = base_path + fileName2;
		}
	}

	function showImageProps(base_path) {
		form = document.adminForm;
		value = getSelectedValue( 'adminForm', 'imagelist' );
		parts = value.split( '|' );
		form._source.value = parts[0];
		setSelectedValue( 'adminForm', '_align', parts[1] || '' );
		form._alt.value = parts[2] || '';
		form._border.value = parts[3] || '0';
		form._caption.value = parts[4] || '';
		setSelectedValue( 'adminForm', '_caption_position', parts[5] || '' );
		setSelectedValue( 'adminForm', '_caption_align', parts[6] || '' );
		form._width.value = parts[7] || '';
	
		//previewImage( 'imagelist', 'view_imagelist', base_path );
		srcImage = eval( "document." + 'view_imagelist' );
		srcImage.src = base_path + parts[0];
	}

	function applyImageProps() {
		form = document.adminForm;
		if (!getSelectedValue( 'adminForm', 'imagelist' )) {
			alert( "Select and image from the list" );
			return;
		}
		value = form._source.value + '|'
		+ getSelectedValue( 'adminForm', '_align' ) + '|'
		+ form._alt.value + '|'
		+ parseInt( form._border.value ) + '|'
		+ form._caption.value + '|'
		+ getSelectedValue( 'adminForm', '_caption_position' ) + '|'
		+ getSelectedValue( 'adminForm', '_caption_align' ) + '|'
		+ form._width.value;
		chgSelectedValue( 'adminForm', 'imagelist', value );
	}
	
</script>
<?php 

jimport( 'joomla.application.component.view' );
 
class MosimageViewOptions extends JView {

	public function display($tpl = null) {
		$this->setLayout('form');
		$temps = null;
		$path = null;
		$folders =array();
		$folders[] = JHTML::_('select.option','/');
		$images = array();
		$imagePath = JPATH_SITE .'/images/stories';
		$folderPath = '/';
		$this->ReadImages($imagePath, $folderPath, $folders, $images);
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$id = JRequest::getVar( 'id', $cid[0], '', 'int' );
		$app = &JFactory::getApplication();
		$path = $app->getSiteURL() .'/images/stories';
		
		$lists['folders'] =  $this->getImageFolders($folders);
		$lists['imagelist'] = $this->GetSavedImages( $id, $path );
		$lists['imagefiles']= $this->GetImages( $images, $path, $folders );
		$lists['_align'] = JHTML::_('list.positions', '_align');
		$lists['_caption_align'] = JHTML::_('list.positions',  '_caption_align', null, ' disabled="disabled" ' );
		$pos[] = JHTML::_('select.option','bottom',JText::_('BOTTOM') );
		$pos[] = JHTML::_('select.option','top', JText::_('TOP') );
		$lists['_caption_position'] = JHTML::_('select.genericlist', $pos, '_caption_position', 'class="inputbox" size="1" disabled="disabled"', 'value', 'text' );
	
		$this->assignRef('lists',$lists);
		$this->assignRef('images', $images);
		$this->assign('id',$id);
		
		parent::display($tpl);
	}

	private function getImageFolders( &$folder ) {
		$javascript 	= "onchange=\"changeDynaList( 'imagefiles', folderimages, document.adminForm.folders.options[document.adminForm.folders.selectedIndex].value, 0, 0);\"";
		return JHTML::_('select.genericlist', $folder, 'folders', 'class="inputbox" size="1" '. $javascript,'value', 'text', '/' );
	}

	private function GetImages( &$images, $path, $base='/' ) {
		if ( is_array($base) && count($base) > 0 ) {
			if ( $base[0]->value != '/' ) {
				$base = $base[0]->value .'/';
			} else {
				$base = $base[0]->value;
			}
		} else {
			$base = '/';
		}
		if ( !isset($images[$base] ) ) {
			$images[$base][] = JHTML::_('select.option', '' );
		}
		$javascript	= "onchange=\"previewImage( 'imagefiles', 'view_imagefiles', '$path/' )\" onfocus=\"previewImage( 'imagefiles', 'view_imagefiles', '$path/' )\"";
		$getimages	= JHTML::_('select.genericlist', $images[$base], 'imagefiles', 'class="inputbox" size="10" multiple="multiple" '. $javascript , 'value', 'text', null );
		return $getimages;
	}

	/**
	 * Internal function to recursive scan the media manager directories
	 * @param string Path to scan
	 * @param string root path of this folder
	 * @param array  Value array of all existing folders
	 * @param array  Value array of all existing images
	 */
	private function ReadImages( $imagePath, $folderPath, &$folders, &$images ) {
		$imgFiles = $this->mosReadDirectory( $imagePath );
		
		foreach ($imgFiles as $file) {
			$ff_ 	= $folderPath . $file .'/';
			$ff 	= $folderPath . $file;
			$i_f 	= $imagePath .'/'. $file;

			if ( is_dir( $i_f ) && $file != 'CVS' && $file != '.svn') {
				$folders[] = JHTML::_('select.option',$ff_);
				$this->ReadImages( $i_f, $ff_, $folders, $images );
			} else if ( preg_match( '/[bB][mM][pP]|[gG][iI][fF]|[jJ][pP][gG]|[pP][nN][gG]/', $file ) && is_file( $i_f ) ) {
				// leading / we don't need
				$imageFile = substr( $ff, 1 );
				$images[$folderPath][] = JHTML::_('select.option',$imageFile, $file );
			}
		}
	}

	/**
	 * Utility function to read the files in a directory
	 * @param string The file system path
	 * @param string A filter for the names
	 * @param boolean Recurse search into sub-directories
	 * @param boolean True if to prepend the full path to the file name
	 */
	private function mosReadDirectory( $path, $filter='.', $recurse=false, $fullpath=false  ) {
		$arr = array();
		if (!@is_dir( $path )) {
			return $arr;
		}
		$handle = opendir( $path );
		while ($file = readdir($handle)) {
			$dir = $this->mosPathName( $path.'/'.$file, false );
			$isDir = is_dir( $dir );
			if (($file != ".") && ($file != "..")) {
				if (preg_match( "/$filter/", $file )) {
					if ($fullpath) {
						$arr[] = trim( $this->mosPathName( $path.'/'.$file, false ) );
					} else {
						$arr[] = trim( $file );
					}
				}
				if ($recurse && $isDir) {
					$arr2 = $this->mosReadDirectory( $dir, $filter, $recurse, $fullpath );
					$arr = array_merge( $arr, $arr2 );
				}
			}
		}
		closedir($handle);
		asort($arr);
		return $arr;
	}

	private function mosPathName($p_path, $p_addtrailingslash = true){
		jimport('joomla.filesystem.path');
		$path = JPath::clean($p_path);
		if ($p_addtrailingslash) {
			$path = rtrim($path, DS) . DS;
		}
		return $path;
	}
	
	private function GetSavedImages( $id, $path ) {
		$db				= & JFactory::getDBO();
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_content'.DS.'tables');
		$row = & JTable::getInstance('content');
		$row->load($id);
		if (trim( $row->images )) {
			$row->images = explode( "\n", $row->images );
		} else {
			$row->images = array();
		}
		$images2 = array();
		foreach( $row->images as $file ) {
			$temp = explode( '|', $file );
			if( strrchr($temp[0], '/') ) {
				$filename = substr( strrchr($temp[0], '/' ), 1 );
			} else {
				$filename = $temp[0];
			}
			$images2[] = JHTML::_('select.option', $file, $filename );
		}
		$javascript	= "onchange=\"previewImage( 'imagelist', 'view_imagelist', '$path/' ); showImageProps( '$path/' ); \"";
		$imagelist 	= JHTML::_('select.genericlist', $images2, 'imagelist', 'class="inputbox" size="10" '. $javascript, 'value', 'text' );
		return $imagelist;
	}
}